//=======================================================================
// DingMee Translator
// URLs: http://chrm.info/cms/dingmee-translator
// Copyright (C) 2012, Christoph Maciejewski
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//=======================================================================

import QtQuick 1.1
import com.nokia.meego 1.0

Page {
    id: about1
    tools: commonTools

    Rectangle {
            color: "#00b1a7"
            width: parent.width
            height: childrenRect.height

            Label {
                id: label2
                x: 10
                y: 0
                width: parent.width - 40
                height: 65
                color: "#ffffff"
                text: "DingMee <font size='-5'>About</font>"
                verticalAlignment: Text.AlignVCenter
                horizontalAlignment: Text.AlignLeft
                font.pixelSize: 32
                font.bold: false
            }
    }

    Rectangle {
            id:aboutScreen
            border.width: 0
            anchors.top: parent.top
            anchors.topMargin: 85
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 1
            anchors.left: parent.left
            anchors.leftMargin: 10
            anchors.right: parent.right
            anchors.rightMargin: 10
            color: "transparent"

            Flickable {
                id: flickArea
                anchors.fill: parent
                contentWidth: label1.width
                contentHeight: label1.height
                flickableDirection: Flickable.VerticalFlick
                clip: true

                Label {
                    id: iconAbout
                    width: 80
                    height: 80
                    anchors.right: parent.right
                    anchors.rightMargin: 3
                    anchors.top: parent.top
                    anchors.topMargin: 5

                    Image {
                        id: icon80
                        source: "qrc:/images/dingmee64.png"
                    }
                }

                Label {
                    id: label1
                    anchors.top: parent.top
                    wrapMode: Text.WordWrap
                    //font.pointSize: label2.font.pointSize-6
                    text: "<b>DingMee</b><br>Offline Translator<br><br>&copy; by Christoph Maciejewski <br>"
                          + "<a href='http://chrm.info/cms/dingmee-translator'>http://chrm.info/cms/dingmee-translator</a><br><br>Version: <i>0.1.7</i><br>"
                          + "<a href='http://chrm.info/cms/dingmee-translator-dicts'>Dictionary info</a><br><hr>"
                          + "This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; See the <a href='http://www.gnu.org/copyleft/gpl.html'>GNU General Public License for more details.</a>"
                          + "<br><hr><br>Request sourcecode: <a href='mailto:chrm@users.sf.net'>eMail</a>";
                    width:aboutScreen.width
                    onLinkActivated: Qt.openUrlExternally(link)

                }
            }

            ScrollDecorator {
                flickableItem: flickArea
            }
    }


}
