//=======================================================================
// DingMee Translator
// URLs: http://chrm.info/cms/dingmee-translator
// Copyright (C) 2012, Christoph Maciejewski
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//=======================================================================

import QtQuick 1.1
import com.nokia.meego 1.0
import Translator 1.0
import QtMobility.feedback 1.1
import SettingsManager 1.0

Page {
    id: page1
    tools: commonTools

    SettingsManager {
        id: settingsmanager
    }

    function clearLangList() {
        if(dialogLang.model.count > 0) {
            console.log("CLEAR:"+dialogLang.model.count);
            dialogLang.model.clear();
        }

        // This is an ugly hack to prevent repaint problems
        // with dialog and new appended entries.
        dialogLang.model.insert(0, { name: "" });
    }

    function updateLangList() {
        if(settingsmanager.isDictAvailable(0))
            dialogLang.model.append({ name: "de-en (german-english)" });
        if(settingsmanager.isDictAvailable(1))
            dialogLang.model.append({ name: "en-es (english-spanish)" });
        if(settingsmanager.isDictAvailable(2))
            dialogLang.model.append({ name: "en-pl (english-polish)" });
        if(settingsmanager.isDictAvailable(3))
            dialogLang.model.append({ name: "en-it (english-italian)" });
        if(settingsmanager.isDictAvailable(4))
            dialogLang.model.append({ name: "en-ru (english-russian)" });
        if(settingsmanager.isDictAvailable(5))
            dialogLang.model.append({ name: "en-fi (english-finnish)" });
        if(settingsmanager.isDictAvailable(6))
            dialogLang.model.append({ name: "en-cmn (english-chinese/mandarin)" });
        if(settingsmanager.isDictAvailable(7))
            dialogLang.model.append({ name: "en-ja (english-japanese)" });
        if(settingsmanager.isDictAvailable(8))
            dialogLang.model.append({ name: "en-fr (english-french)" });
        if(settingsmanager.isDictAvailable(9))
            dialogLang.model.append({ name: "en-arb (english-arabic)" });
        if(settingsmanager.isDictAvailable(10))
            dialogLang.model.append({ name: "en-cs (english-czech)" });
        if(settingsmanager.isDictAvailable(11))
            dialogLang.model.append({ name: "en-sv (english-swedish)" });
        if(settingsmanager.isDictAvailable(12))
            dialogLang.model.append({ name: "en-el (english-greek)" });
        if(settingsmanager.isDictAvailable(13))
            dialogLang.model.append({ name: "en-he (english-hebrew)" });
        if(settingsmanager.isDictAvailable(14))
            dialogLang.model.append({ name: "en-pt (english-portuguese)" });
        if(settingsmanager.isDictAvailable(15))
            dialogLang.model.append({ name: "en-hu (english-hungarian)" });
        if(settingsmanager.isDictAvailable(16))
            dialogLang.model.append({ name: "es-de (spanish-german)" });
        if(settingsmanager.isDictAvailable(17))
            dialogLang.model.append({ name: "de-pl (german-polish)" });
        if(settingsmanager.isDictAvailable(18))
            dialogLang.model.append({ name: "de-fr (german-french)" });        
        if(settingsmanager.isDictAvailable(19))
            dialogLang.model.append({ name: "de-it (german-italian)" });
        if(settingsmanager.isDictAvailable(20))
            dialogLang.model.append({ name: "ru-he (russian-hebrew)" });
        if(settingsmanager.isDictAvailable(21))
            dialogLang.model.append({ name: "ru-pl (russian-polish)" });
        if(settingsmanager.isDictAvailable(22))
            dialogLang.model.append({ name: "en-no (english-norwegian)" });
        if(settingsmanager.isDictAvailable(23))
            dialogLang.model.append({ name: "en-ro (english-romanian)" });
        if(settingsmanager.isDictAvailable(24))
            dialogLang.model.append({ name: "en-tr (english-turkish)" });
        if(settingsmanager.isDictAvailable(25))
            dialogLang.model.append({ name: "en-hi (english-hindi)" });
        if(settingsmanager.isDictAvailable(26))
            dialogLang.model.append({ name: "de-tr (german-turkish)" });
        if(settingsmanager.isDictAvailable(27))
            dialogLang.model.append({ name: "de-cmn (german-chinese/mandarin)" });
        if(settingsmanager.isDictAvailable(28))
            dialogLang.model.append({ name: "it-fr (italian-french)" });
        if(settingsmanager.isDictAvailable(29))
            dialogLang.model.append({ name: "es-fr (spanish-french)" });
        if(settingsmanager.isDictAvailable(30))
            dialogLang.model.append({ name: "en-ko (english-korean)" });
        if(settingsmanager.isDictAvailable(31))
            dialogLang.model.append({ name: "en-vi (english-vietnamese)" });
    }

    Component.onCompleted: {
        updateLangList();
    }

    WorkerScript {
             id: myWorker
             source: "background.js"
             onMessage: {
                 if(textfield1.text.length > 2) {
                     var hit = false;
                     var retVal = dingtrans.translate(textfield1.text, buttonLang.text);
                     textarea1.text = retVal;

                     // Append only new words to history
                     if(retVal !== "<i>Sorry, no results.</i>") {
                         for(var i=0; i<dialogHistory.model.count; i++) {
                             if(dialogHistory.model.get(i).name === textfield1.text)
                                 hit = true;
                         }

                         if(!hit)
                             dialogHistory.model.append({name: textfield1.text});
                     }
                 } else {
                     textarea1.text = "<i><font color='red'>Expression to short!</font></i>";
                 }

                 busy01.running = false;
                 busy01.visible = false;
                 buttonLang.visible = true;                 
             }
         }

    Dialog {
        id: langNotAvailableDialog

        title: Rectangle {
             id: titleField
             height: 2
             width: parent.width
             color: "green"
           }

           content:Item {
             id: notavailItem
             height: 150
             width: parent.width
             Text {
               id: notavaiText
               font.pixelSize: 22
               anchors.centerIn: parent
               color: "white"
               text: "Language not available. Download first!"
             }
           }

           buttons: Button {
               text: "OK";
               onClicked: langNotAvailableDialog.accept()
           }
    }
    SelectionDialog {
             id: dialogLang
             titleText: "Select Dictionary:"

             model: ListModel {                
             }             

             onAccepted: {
                 var string = dialogLang.model.get(dialogLang.selectedIndex).name.split('(')[0].trim();

                 if(string !== "") {
                    buttonLang.text = string;
                    textarea1.text = "<font color='grey'>Selected dictionary: "+string+"</font>"
                 }

                 /*if(!settingsmanager.isDictAvailable(dialogLang.selectedIndex)) {
                     // Language not available, show info
                     langNotAvailableDialog.open();                     
                 } else {
                     buttonLang.text = string;
                     textarea1.text = "<font color='grey'>Selected dictionary: "+string+"</font>"
                 }*/
             }

             onRejected: {
                 console.log("LANG-LIST: "+dialogLang.model.count);
             }
         }

    SelectionDialog {
             id: dialogHistory
             titleText: "Search History:"

             buttons: Button {
                 id: clearHistoryButton;
                 text: "Clear History";
                 onClicked: {
                     dialogHistory.model.clear();
                 }
             }

             model: ListModel {
             }

             onAccepted: {
                 var string = dialogHistory.model.get(dialogHistory.selectedIndex).name.split('(')[0].trim();
                 textfield1.text = string;
                 button1.clicked();
             }
         }

    Button {
        id: buttonHistory
        x: 3
        y: 73
        width: 70
        height: 47
        iconSource: "image://theme/icon-m-common-combobox-arrow"

        onClicked: {
            dialogHistory.open();
        }
    }

    TextField {
        id: textfield1
        x: buttonHistory.width + 6
        y: 73
        width: parent.width-buttonHistory.width-button1.width-12
        height: 47
        text: ""
        placeholderText: "Type here"
        platformStyle: TextFieldStyle { paddingRight: clearText.width }

        onAccepted: {            
            textarea1.text = "<i>Please wait...</i>";
            textarea1.cursorPosition = 1;
            busy01.running = true;
            busy01.visible = true;
            buttonLang.visible = false;
            textfield1.selectAll();            
            myWorker.sendMessage( { searchword: textfield1.text} );            
        }

        Image {
             id: clearText

             anchors {
                 top: parent.top;                 
                 right: parent.right;
                 margins: 3;
             }

             fillMode: Image.PreserveAspectFit
             smooth: true; visible: textfield1.text
             source: "image://theme/icon-m-input-clear"
             height: 42
             width: 42             

             MouseArea {
                 id: clear
                 anchors { horizontalCenter: parent.horizontalCenter; verticalCenter: parent.verticalCenter }
                 height: textfield1.height; width: textfield1.height
                 onClicked: {
                     textfield1.text = ""
                 }
             }
         }
    }



    Button {
        id: button1
        x: textfield1.width+3+textfield1.x
        y: 73
        width: 70
        height: 47        
        iconSource: "image://theme/icon-m-common-search"



        HapticsEffect {
             id: rumbleEffect
             attackIntensity: 0.0
             attackTime: 50
             intensity: 1.0
             duration: 50
             fadeTime: 50
             fadeIntensity: 0.0
        }

        onClicked: {
            //textarea1.text = dingtrans.translate(textfield1.text);
            busy01.running = true;
            busy01.visible = true;
            buttonLang.visible = false;
            textfield1.selectAll();
            textarea1.text = "<i>Please wait...</i>";            
            textarea1.cursorPosition = 1;
            flickArea.resizeContent( textarea1.width, textarea1.height, 0);
            flickArea.returnToBounds();
            rumbleEffect.running = true;
            myWorker.sendMessage( { searchword: textfield1.text} );            
        }
    }

    Translator {
        id: dingtrans
    }

    Rectangle {
            color: "#00b1a7"
            width: parent.width
            height: childrenRect.height

            Label {
                id: label1
                x: 10
                y: 0
                width: parent.width - 40
                height: 65
                color: "#ffffff"
                text: "DingMee <font size='-5'>Offline Translator</font>"
                verticalAlignment: Text.AlignVCenter
                horizontalAlignment: Text.AlignLeft
                font.pixelSize: 32
                font.bold: false
            }

            BusyIndicator {
                id: busy01
                x: parent.width - 40
                y: 15
                width: 30
                height: 30
                running: false
                visible: false
            }

            Button {
                id: buttonLang
                x: parent.width - 156
                y: 8
                width: 152
                height: 50
                text: settingsmanager.getLastLang()
                font: {
                    font.family = button1.font.family;
                    font.pointSize = button1.font.pointSize-1;
                    font.bold = false;
                }
                iconSource: "image://theme/icon-m-common-combobox-arrow"

                opacity: 0.8

                onClicked: {
                    dialogLang.open();
                }
            }
        }


    Rectangle {
            id:helpScreen
            y: 120
            border.width: 0
            height: parent.height-100
            anchors.top: textfield1.bottom
            anchors.topMargin: 5
            anchors.right: parent.right
            anchors.rightMargin: 0
            anchors.left: parent.left
            anchors.leftMargin: 0
            opacity: 1.0

            Flickable {
                id: flickArea
                anchors.fill: parent
                contentWidth: textarea1.width
                contentHeight: textarea1.height
                flickableDirection: Flickable.VerticalFlick
                clip: true

                TextArea {
                    id: textarea1
                    readOnly: true
                    text: "<font color='grey'>Welcome to <b>DingMee</b>!</font>"
                    width:helpScreen.width
                    //font.pointSize: label1.font.pointSize-2
                    //wrapMode: Text.WordWrap
                }
            }

            ScrollDecorator {
                flickableItem: flickArea
            }
    }






}
