//=======================================================================
// DingMee Translator
// URLs: http://chrm.info/cms/dingmee-translator
// Copyright (C) 2012, Christoph Maciejewski
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//=======================================================================

import QtQuick 1.1
import com.nokia.meego 1.0
import SettingsManager 1.0

Page {
    id: settings1
    tools: commonTools

    SettingsManager {
        id: settingsmanager
    }

    function checkBoxState(_checkBox, _num) {
        var availableText = "&nbsp;<font color='green' size='-3'>available</font>";

        if(settingsmanager.isDictAvailable(_num)) {
            _checkBox.text = _checkBox.text + availableText;
            _checkBox.checked = true
            _checkBox.opacity = 0.5;
        } else {
            _checkBox.enabled = true;
            _checkBox.checked = false;
            _checkBox.opacity = 1.0;
        }
    }

    function checkDictStates() {
        // Check dicts and enable/disable checkboxes
        checkbox_de_en.text = "[de-en] German / English <br><font size='-3'>(13MiB) Deutsch</font>";
        checkbox_en_es.text = "[en-es] English / Spanish <br><font size='-3'>(3MiB) Español</font>";
        checkbox_en_pl.text = "[en-pl] English / Polish <br><font size='-3'>(1.5MiB) Polski</font>";
        checkbox_en_it.text = "[en-it] English / Italian <br><font size='-3'>(2MiB) Italiano</font>";
        checkbox_en_ru.text = "[en-ru] English / Russian <br><font size='-3'>(5MiB) Русский</font>";
        checkbox_en_fi.text = "[en-fi] English / Finnish <br><font size='-3'>(4MiB) Suomi</font>";
        checkbox_en_cmn.text = "[en-cmn] English / Chinese-Mandarin <br><font size='-3'>(2.1MiB) 中文</font>";
        checkbox_en_ja.text = "[en-ja] English / Japanese <br><font size='-3'>(2.5MiB) 日本語</font>";
        checkbox_en_fr.text = "[en-fr] English / French <br><font size='-3'>(3.2MiB) Français</font>";
        checkbox_en_arb.text = "[en-arb] English / Arabic <br><font size='-3'>(1MiB) العربية</font>";
        checkbox_en_cs.text = "[en-cs] English / Czech <br><font size='-3'>(1.6MiB) Česky</font>";
        checkbox_en_sv.text = "[en-sv] English / Swedish <br><font size='-3'>(1.6MiB) Svenska</font>";
        checkbox_en_el.text = "[en-el] English / Greek <br><font size='-3'>(2MiB) Ελληνικά</font>";
        checkbox_en_he.text = "[en-he] English / Hebrew <br><font size='-3'>(0.8MiB) עברית‎</font>";
        checkbox_en_pt.text = "[en-pt] English / Portuguese <br><font size='-3'>(2MiB) Português</font>";
        checkbox_en_hu.text = "[en-hu] English / Hungarian <br><font size='-3'>(1.3MiB) Magyar</font>";
        checkbox_es_de.text = "[es-de] Spanish / German <br><font size='-3'>(0.8MiB)</font>";
        checkbox_de_pl.text = "[de-pl] German / Polish <br><font size='-3'>(0.7MiB)</font>";
        checkbox_de_fr.text = "[de-fr] German / French <br><font size='-3'>(1.1MiB)</font>";
        checkbox_de_it.text = "[de-it] German / Italian <br><font size='-3'>(0.8MiB)</font>";
        checkbox_ru_he.text = "[ru-he] Russian / Hebrew <br><font size='-3'>(0.8MiB)</font>";
        checkbox_ru_pl.text = "[ru-pl] Russian / Polish <br><font size='-3'>(1.2MiB)</font>";
        checkbox_en_no.text = "[en-no] English / Norwegian <br><font size='-3'>(1.2MiB) Norsk</font>";
        checkbox_en_ro.text = "[en-ro] English / Romanian <br><font size='-3'>(1.0MiB) Română</font>";
        checkbox_en_tr.text = "[en-tr] English / Turkish <br><font size='-3'>(0.9MiB) Türkçe</font>";
        checkbox_en_hi.text = "[en-hi] English / Hindi <br><font size='-3'>(0.5MiB) हिन्दी</font>";
        checkbox_de_tr.text = "[de_tr] German / Turkish <br><font size='-3'>(0.5MiB)</font>";
        checkbox_de_cmn.text = "[de_cmn] German / Chinese-Mandarin <br><font size='-3'>(1.3MiB)</font>";
        checkbox_it_fr.text = "[it_fr] Italian / French <br><font size='-3'>(0.7MiB)</font>";
        checkbox_es_fr.text = "[es_fr] Spanish / French <br><font size='-3'>(0.8MiB)</font>";
        checkbox_en_ko.text = "[es_ko] English / Korean <br><font size='-3'>(0.9MiB) 한국어</font>";
        checkbox_en_vi.text = "[es_vi] English / Vietnamese <br><font size='-3'>(0.5MiB) Tiếng Việt</font>";

        checkBoxState(checkbox_de_en, 0);
        checkBoxState(checkbox_en_es, 1);
        checkBoxState(checkbox_en_pl, 2);
        checkBoxState(checkbox_en_it, 3);
        checkBoxState(checkbox_en_ru, 4);
        checkBoxState(checkbox_en_fi, 5);
        checkBoxState(checkbox_en_cmn, 6);        
        checkBoxState(checkbox_en_ja, 7);
        checkBoxState(checkbox_en_fr, 8);
        checkBoxState(checkbox_en_arb, 9);
        checkBoxState(checkbox_en_cs, 10);
        checkBoxState(checkbox_en_sv, 11);
        checkBoxState(checkbox_en_el, 12);
        checkBoxState(checkbox_en_he, 13);
        checkBoxState(checkbox_en_pt, 14);
        checkBoxState(checkbox_en_hu, 15);
        checkBoxState(checkbox_es_de, 16);
        checkBoxState(checkbox_de_pl, 17);
        checkBoxState(checkbox_de_fr, 18);        
        checkBoxState(checkbox_de_it, 19);
        checkBoxState(checkbox_ru_he, 20);
        checkBoxState(checkbox_ru_pl, 21);        
        checkBoxState(checkbox_en_no, 22);
        checkBoxState(checkbox_en_ro, 23);
        checkBoxState(checkbox_en_tr, 24);
        checkBoxState(checkbox_en_hi, 25);        
        checkBoxState(checkbox_de_tr, 26);
        checkBoxState(checkbox_de_cmn, 27);
        checkBoxState(checkbox_it_fr, 28);
        checkBoxState(checkbox_es_fr, 29);
        checkBoxState(checkbox_en_ko, 30);
        checkBoxState(checkbox_en_vi, 31);
    }

    Component.onCompleted: {
        if(settingsmanager.isDictAvailable()) {
            labelStatus.text = "<font color='green'>Local dictionaries available.</font>";
            buttonDownload.text = "Download Selected";
            buttonRemoveAll.enabled = true;
        } else {
            labelStatus.text = "<font color='red'>No local dictionary found. Download first!</font>";
            buttonDownload.text = "Download Selected";
        }

        buttonDownload.enabled = false;
        checkDictStates();
    }

    Rectangle {
        id: rectangle1
            color: "#00b1a7"
            width: parent.width
            height: childrenRect.height

            Label {
                id: label2
                x: 10
                y: 0
                width: parent.width - 40
                height: 65
                color: "#ffffff"
                text: "DingMee <font size='-5'>Settings</font>"
                verticalAlignment: Text.AlignVCenter
                horizontalAlignment: Text.AlignLeft
                font.pixelSize: 32
                font.bold: false
            }
    }


    Label {
        id: icon1
        width: 128
        height: 128
        anchors.left: parent.left
        anchors.leftMargin: 3
        anchors.top: label3.bottom
        anchors.topMargin: 5

        Image {
            id: download1
            source: "qrc:/images/download.png"
        }
    }

    Button {
        id: buttonCancel
        anchors.left: icon1.right
        anchors.leftMargin: 3
        anchors.top: label3.bottom
        anchors.topMargin: 5
        anchors.right: parent.right
        anchors.rightMargin: 3
        text: "Cancel"        

        onClicked: {
            settingsmanager.cancelFtp();            
            buttonDownload.visible = true;
            visible = false;

            flickArea.enabled = true;
            flickArea.opacity = 1.0;

            checkDictStates();

            timerFTP.stop();
            labelStatus.text = settingsmanager.getStatus();
        }
        visible: false
    }    

    Button {
        id: buttonDownload
        anchors.left: icon1.right
        anchors.leftMargin: 3
        anchors.top: label3.bottom
        anchors.topMargin: 3
        anchors.right: parent.right
        anchors.rightMargin: 3
        text: "Download now"
        iconSource: "image://theme/icon-s-transfer-download"
        onClicked: {            
            askDownloadDialog.open();
        }
    }

    Button {
        id: buttonRemoveAll
        anchors.left: icon1.right
        anchors.leftMargin: 3
        anchors.top: buttonDownload.bottom
        anchors.topMargin: 5        
        text: "Remove All..."
        iconSource: "image://theme/icon-m-toolbar-delete"
        enabled: false
        width: parent.width/2

        onClicked: {
            askDeleteDialog.open();
        }
    }

    Button {
        id: buttonaboutDict
        anchors.left: buttonRemoveAll.right
        anchors.leftMargin: 3
        anchors.top: buttonDownload.bottom
        anchors.topMargin: 5
        anchors.right: parent.right
        anchors.rightMargin: 3
        //text: "About"
        iconSource: "image://theme/icon-l-user-guide-main-view"

        onClicked: {
            aboutText.text = "<b><u>About dictionary files</u></b>:<br><font size='-2'>The de-en dict is provided by <br>Frank Richter (frank.richter@hrz.tu-chemnitz.de)<br>Visit http://dict.tu-chemnitz.de/ for<br>the online version!<br>All other files are generated from the<br>wiktionary.org project.<br>Many thanks to Matthias Buchmeier</font><br>" + settingsmanager.getDictInfo();
            aboutDict.open();
        }
    }

    Label {
        id: label3
        x: 159
        text: "Dictionary management"
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: rectangle1.bottom
        anchors.topMargin: 3
        horizontalAlignment: Text.AlignHCenter
    }



    Rectangle {
            id:dictInfoScreen
            border.width: 0
            anchors.top: icon1.bottom
            anchors.topMargin: 3
            anchors.left: parent.left
            anchors.leftMargin: 5
            anchors.right: parent.right
            anchors.rightMargin: 5
            anchors.bottom: labelStatus.top
            anchors.bottomMargin: 3
            color: "transparent"

            Flickable {
                id: flickArea
                anchors.fill: parent
                contentWidth: info1.width
                contentHeight: info1.height+(35*checkbox_de_en.height)
                flickableDirection: Flickable.VerticalFlick
                clip: true

                Label {
                    id: info1                    
                    width: dictInfoScreen.width
                    wrapMode: Text.WordWrap
                    text: "Select dictionaries for download:"
                }

                CheckBox {
                    id: checkbox_de_en
                    anchors.top: info1.bottom
                    anchors.topMargin: 5
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(0)) {
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_es
                    anchors.top: checkbox_de_en.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(1)) {
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_pl
                    anchors.top: checkbox_en_es.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(2)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_it
                    anchors.top: checkbox_en_pl.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(3)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_ru
                    anchors.top: checkbox_en_it.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(4)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_fi
                    anchors.top: checkbox_en_ru.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(5)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_cmn
                    anchors.top: checkbox_en_fi.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(6)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_ja
                    anchors.top: checkbox_en_cmn.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(7)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_fr
                    anchors.top: checkbox_en_ja.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(8)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_arb
                    anchors.top: checkbox_en_fr.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(9)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_cs
                    anchors.top: checkbox_en_arb.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(10)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_sv
                    anchors.top: checkbox_en_cs.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(11)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_el
                    anchors.top: checkbox_en_sv.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(12)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_he
                    anchors.top: checkbox_en_el.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(13)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_pt
                    anchors.top: checkbox_en_he.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(14)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_hu
                    anchors.top: checkbox_en_pt.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(15)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_es_de
                    anchors.top: checkbox_en_hu.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(16)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_de_pl
                    anchors.top: checkbox_es_de.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(17)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_de_fr
                    anchors.top: checkbox_de_pl.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(18)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_de_it
                    anchors.top: checkbox_de_fr.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(19)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_ru_he
                    anchors.top: checkbox_de_it.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(20)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_ru_pl
                    anchors.top: checkbox_ru_he.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(21)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_no
                    anchors.top: checkbox_ru_pl.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(22)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_ro
                    anchors.top: checkbox_en_no.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(23)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_tr
                    anchors.top: checkbox_en_ro.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(24)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_hi
                    anchors.top: checkbox_en_tr.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(25)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_de_tr
                    anchors.top: checkbox_en_hi.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(26)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_de_cmn
                    anchors.top: checkbox_de_tr.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(27)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_it_fr
                    anchors.top: checkbox_de_cmn.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(28)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_es_fr
                    anchors.top: checkbox_it_fr.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(29)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_ko
                    anchors.top: checkbox_es_fr.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(30)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }

                CheckBox {
                    id: checkbox_en_vi
                    anchors.top: checkbox_en_ko.bottom
                    anchors.topMargin: 3
                    onCheckedChanged: {
                        if(settingsmanager.isDictAvailable(31)){
                            checked = true;
                        } else
                            buttonDownload.enabled = true;
                    }
                }
            }

            ScrollDecorator {
                flickableItem: flickArea
            }
    }    

    Label {
        id: labelStatus
        x: 0
        text: "..."
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.bottom: parent.bottom
        anchors.topMargin: 3
        horizontalAlignment: Text.AlignHCenter
    }

    Dialog {
        id: aboutDict
        opacity: 0.8

        title: Rectangle {
             id: titleField
             height: 2
             width: parent.width
             color: "green"
           }

           content:Item {
             id: aboutItem
             height: 810
             width: parent.width
             Text {
               id: aboutText
               font.pixelSize: 22
               anchors.centerIn: parent
               color: "white"               
             }
           }           
    }

    QueryDialog  {
        id: askDownloadDialog
        titleText: "Download Dictionaries"
        message:  "You can now download selected dictionaries.";
        acceptButtonText: "Download"
        rejectButtonText: "Cancel"
        onAccepted: {            
            var doDownload=false;

            if(checkbox_de_en.checked && !settingsmanager.isDictAvailable(0)) {settingsmanager.downloadDict(0); doDownload=true;}
            if(checkbox_en_es.checked && !settingsmanager.isDictAvailable(1)) {settingsmanager.downloadDict(1); doDownload=true;}
            if(checkbox_en_pl.checked && !settingsmanager.isDictAvailable(2)) {settingsmanager.downloadDict(2); doDownload=true;}
            if(checkbox_en_it.checked && !settingsmanager.isDictAvailable(3)) {settingsmanager.downloadDict(3); doDownload=true;}
            if(checkbox_en_ru.checked && !settingsmanager.isDictAvailable(4)) {settingsmanager.downloadDict(4); doDownload=true;}
            if(checkbox_en_fi.checked && !settingsmanager.isDictAvailable(5)) {settingsmanager.downloadDict(5); doDownload=true;}
            if(checkbox_en_cmn.checked && !settingsmanager.isDictAvailable(6)) {settingsmanager.downloadDict(6); doDownload=true;}
            if(checkbox_en_ja.checked && !settingsmanager.isDictAvailable(7)) {settingsmanager.downloadDict(7); doDownload=true;}
            if(checkbox_en_fr.checked && !settingsmanager.isDictAvailable(8)) {settingsmanager.downloadDict(8); doDownload=true;}
            if(checkbox_en_arb.checked && !settingsmanager.isDictAvailable(9)) {settingsmanager.downloadDict(9); doDownload=true;}
            if(checkbox_en_cs.checked && !settingsmanager.isDictAvailable(10)) {settingsmanager.downloadDict(10); doDownload=true;}
            if(checkbox_en_sv.checked && !settingsmanager.isDictAvailable(11)) {settingsmanager.downloadDict(11); doDownload=true;}
            if(checkbox_en_el.checked && !settingsmanager.isDictAvailable(12)) {settingsmanager.downloadDict(12); doDownload=true;}
            if(checkbox_en_he.checked && !settingsmanager.isDictAvailable(13)) {settingsmanager.downloadDict(13); doDownload=true;}
            if(checkbox_en_pt.checked && !settingsmanager.isDictAvailable(14)) {settingsmanager.downloadDict(14); doDownload=true;}
            if(checkbox_en_hu.checked && !settingsmanager.isDictAvailable(15)) {settingsmanager.downloadDict(15); doDownload=true;}
            if(checkbox_es_de.checked && !settingsmanager.isDictAvailable(16)) {settingsmanager.downloadDict(16); doDownload=true;}
            if(checkbox_de_pl.checked && !settingsmanager.isDictAvailable(17)) {settingsmanager.downloadDict(17); doDownload=true;}
            if(checkbox_de_fr.checked && !settingsmanager.isDictAvailable(18)) {settingsmanager.downloadDict(18); doDownload=true;}            
            if(checkbox_de_it.checked && !settingsmanager.isDictAvailable(19)) {settingsmanager.downloadDict(19); doDownload=true;}
            if(checkbox_ru_he.checked && !settingsmanager.isDictAvailable(20)) {settingsmanager.downloadDict(20); doDownload=true;}
            if(checkbox_ru_pl.checked && !settingsmanager.isDictAvailable(21)) {settingsmanager.downloadDict(21); doDownload=true;}            
            if(checkbox_en_no.checked && !settingsmanager.isDictAvailable(22)) {settingsmanager.downloadDict(22); doDownload=true;}
            if(checkbox_en_ro.checked && !settingsmanager.isDictAvailable(23)) {settingsmanager.downloadDict(23); doDownload=true;}
            if(checkbox_en_tr.checked && !settingsmanager.isDictAvailable(24)) {settingsmanager.downloadDict(24); doDownload=true;}
            if(checkbox_en_hi.checked && !settingsmanager.isDictAvailable(25)) {settingsmanager.downloadDict(25); doDownload=true;}            
            if(checkbox_de_tr.checked && !settingsmanager.isDictAvailable(26)) {settingsmanager.downloadDict(26); doDownload=true;}
            if(checkbox_de_cmn.checked && !settingsmanager.isDictAvailable(27)) {settingsmanager.downloadDict(27); doDownload=true;}
            if(checkbox_it_fr.checked && !settingsmanager.isDictAvailable(28)) {settingsmanager.downloadDict(28); doDownload=true;}
            if(checkbox_es_fr.checked && !settingsmanager.isDictAvailable(29)) {settingsmanager.downloadDict(29); doDownload=true;}
            if(checkbox_en_ko.checked && !settingsmanager.isDictAvailable(30)) {settingsmanager.downloadDict(30); doDownload=true;}
            if(checkbox_en_vi.checked && !settingsmanager.isDictAvailable(31)) {settingsmanager.downloadDict(31); doDownload=true;}


            if(doDownload) {
                settingsmanager.startDownload();
                flickArea.enabled = false;
                flickArea.opacity = 0.5;
                buttonRemoveAll.enabled = false;

                timerFTP.restart();
                buttonDownload.visible = false;
                buttonCancel.visible = true;
            }
        }
    }

    QueryDialog  {
        id: askDeleteDialog
        titleText: "Delete All Dictionaries"
        message:  "Are you sure, you want remove <br><b>all</b> dictionaries from your device?";
        acceptButtonText: "Yes"
        rejectButtonText: "No"
        onAccepted: {
            settingsmanager.removeAllDicts();
            checkDictStates();
        }
    }

    Item {
         Timer {
             id: timerFTP
             interval: 500; running: false; repeat: true
             onTriggered: {
                 labelStatus.text = settingsmanager.getStatus();
                 if(settingsmanager.isDictAvailable()) {
                     labelStatus.text = "<font color='green'>Local dictionaries available.</font>";
                     buttonDownload.text = "Download selected";
                     buttonDownload.enabled = false;
                     buttonDownload.visible = true;
                     buttonCancel.visible = false;
                     checkDictStates();
                     timerFTP.stop();

                     flickArea.enabled = true;
                     flickArea.opacity = 1.0;

                     buttonRemoveAll.enabled = true;
                 }
             }
         }
     }


}
